searchNodes=[{"doc":"The functions here call the corresponding functions on the configured adapter.","ref":"Spandex.html","title":"Spandex","type":"module"},{"doc":"Given a %SpanContext{} , resumes a trace from a different process or service. Span updates for the top span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a second call to update_span/2 and check the return value.","ref":"Spandex.html#continue_trace/3","title":"Spandex.continue_trace/3","type":"function"},{"doc":"Given a trace_id and span_id, resumes a trace from a different process or service. Span updates for the top span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a second call to update_span/2 and check the return value.","ref":"Spandex.html#continue_trace/4","title":"Spandex.continue_trace/4","type":"function"},{"doc":"Given a span struct, resumes a trace from a different process or service. Span updates for the top span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a second call to update_span/2 and check the return value.","ref":"Spandex.html#continue_trace_from_span/3","title":"Spandex.continue_trace_from_span/3","type":"function"},{"doc":"Returns the current %SpanContext{} or an error. DEPRECATION WARNING Expect changes to this in the future, as this will eventualy be refactored to only ever return a %SpanContext{} , or at least to always return something consistent.","ref":"Spandex.html#current_context/1","title":"Spandex.current_context/1","type":"function"},{"doc":"Returns the %Span{} struct for the currently-running span","ref":"Spandex.html#current_span/1","title":"Spandex.current_span/1","type":"function"},{"doc":"Returns the id of the currently-running span.","ref":"Spandex.html#current_span_id/1","title":"Spandex.current_span_id/1","type":"function"},{"doc":"Returns the id of the currently-running trace.","ref":"Spandex.html#current_trace_id/1","title":"Spandex.current_trace_id/1","type":"function"},{"doc":"Returns the context from a given set of HTTP headers, as determined by the adapter.","ref":"Spandex.html#distributed_context/2","title":"Spandex.distributed_context/2","type":"function"},{"doc":"Finishes the current span. Span updates for that span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a call to update_span/2 and check the return value before finishing the span.","ref":"Spandex.html#finish_span/1","title":"Spandex.finish_span/1","type":"function"},{"doc":"Finishes the current trace. Span updates for the top span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a call to update_span/2 and check the return value before finishing the trace.","ref":"Spandex.html#finish_trace/1","title":"Spandex.finish_trace/1","type":"function"},{"doc":"Alters headers to include the outgoing HTTP headers necessary to continue a distributed trace, as determined by the adapter.","ref":"Spandex.html#inject_context/3","title":"Spandex.inject_context/3","type":"function"},{"doc":"Updates the current span with error details. In the case of an invalid value, validation errors are returned.","ref":"Spandex.html#span_error/3","title":"Spandex.span_error/3","type":"function"},{"doc":"Start a new span. Span updates for that span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a second call to update_span/2 and check the return value.","ref":"Spandex.html#start_span/2","title":"Spandex.start_span/2","type":"function"},{"doc":"Starts a new trace. Span updates for the first span may be passed in. They are skipped if they are invalid updates. As such, if you aren't sure if your updates are valid, it is safer to perform a second call to update_span/2 and check the return value.","ref":"Spandex.html#start_trace/2","title":"Spandex.start_trace/2","type":"function"},{"doc":"Updates all spans, whether complete or in-progress. In the case of an invalid update for any span, validation errors are returned.","ref":"Spandex.html#update_all_spans/1","title":"Spandex.update_all_spans/1","type":"function"},{"doc":"Updates the current span. In the case of an invalid update, validation errors are returned.","ref":"Spandex.html#update_span/2","title":"Spandex.update_span/2","type":"function"},{"doc":"Updates the top-most parent span. Any spans that have already been started will not inherit any of the updates from that span. For instance, if you change service , it will not be reflected in already-started spans. In the case of an invalid update, validation errors are returned.","ref":"Spandex.html#update_top_span/1","title":"Spandex.update_top_span/1","type":"function"},{"doc":"","ref":"Spandex.html#t:headers/0","title":"Spandex.headers/0","type":"type"},{"doc":"Used for Span and Trace IDs (type defined by adapters)","ref":"Spandex.html#t:id/0","title":"Spandex.id/0","type":"type"},{"doc":"Unix timestamp in nanoseconds","ref":"Spandex.html#t:timestamp/0","title":"Spandex.timestamp/0","type":"type"},{"doc":"The callbacks required to implement the Spandex.Adapter behaviour.","ref":"Spandex.Adapter.html","title":"Spandex.Adapter","type":"behaviour"},{"doc":"","ref":"Spandex.Adapter.html#c:default_sender/0","title":"Spandex.Adapter.default_sender/0","type":"callback"},{"doc":"","ref":"Spandex.Adapter.html#c:distributed_context/2","title":"Spandex.Adapter.distributed_context/2","type":"callback"},{"doc":"","ref":"Spandex.Adapter.html#c:inject_context/3","title":"Spandex.Adapter.inject_context/3","type":"callback"},{"doc":"","ref":"Spandex.Adapter.html#c:now/0","title":"Spandex.Adapter.now/0","type":"callback"},{"doc":"","ref":"Spandex.Adapter.html#c:span_id/0","title":"Spandex.Adapter.span_id/0","type":"callback"},{"doc":"","ref":"Spandex.Adapter.html#c:trace_id/0","title":"Spandex.Adapter.trace_id/0","type":"callback"},{"doc":"Provides a way of annotating functions to be traced. Span function decorators take an optional argument which is the attributes to update the span with. One of those attributes can be the :tracer in case you want to override the default tracer (e.g., in case you want to use multiple tracers). IMPORTANT If you define multiple clauses for a function, you'll have to decorate all of the ones you want to span. Note: Decorators don't magically do everything. It often makes a lot of sense to use Tracer.update_span from within your function to add details that are only available inside that same function. defmodule Foo do use Spandex.Decorators @decorate trace ( ) def bar ( a ) do a * 2 end @decorate trace ( service : &quot;ecto&quot; , type : &quot;sql&quot; ) def databaz ( a ) do a * 3 end end","ref":"Spandex.Decorators.html","title":"Spandex.Decorators","type":"module"},{"doc":"","ref":"Spandex.Decorators.html#span/0","title":"Spandex.Decorators.span/0","type":"macro"},{"doc":"","ref":"Spandex.Decorators.html#span/1","title":"Spandex.Decorators.span/1","type":"macro"},{"doc":"","ref":"Spandex.Decorators.html#span/2","title":"Spandex.Decorators.span/2","type":"function"},{"doc":"","ref":"Spandex.Decorators.html#span/3","title":"Spandex.Decorators.span/3","type":"function"},{"doc":"","ref":"Spandex.Decorators.html#trace/0","title":"Spandex.Decorators.trace/0","type":"macro"},{"doc":"","ref":"Spandex.Decorators.html#trace/1","title":"Spandex.Decorators.trace/1","type":"macro"},{"doc":"","ref":"Spandex.Decorators.html#trace/2","title":"Spandex.Decorators.trace/2","type":"function"},{"doc":"","ref":"Spandex.Decorators.html#trace/3","title":"Spandex.Decorators.trace/3","type":"function"},{"doc":"Adds request context to the top span of the trace, setting the resource, method, url, service, type and env","ref":"Spandex.Plug.AddContext.html","title":"Spandex.Plug.AddContext","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Spandex.Plug.AddContext.html#call/2","title":"Spandex.Plug.AddContext.call/2","type":"function"},{"doc":"Starts a trace, considering the filters/parameters in the provided options. Opts tracer ( :atom ) Required : The tracing module to be used to start the trace. allowed_route_replacements ( [{:list, :atom}, nil] ): A list of route parts that may be replaced with their actual value. If not set or set to nil, then all will be allowed, unless they are disallowed. - Default: nil disallowed_route_replacements ( {:list, :atom} ): A list of route parts that may not be replaced with their actual value. - Default: [] query_params ( {:list, :atom} ): A list of query params who's value will be included in the resource name. - Default: [] tracer_opts ( :keyword ): Any opts to be passed to the tracer when starting or continuing the trace. - Default: [] You would generally not use allowed_route_replacements and disallowed_route_replacements together.","ref":"Spandex.Plug.AddContext.html#init/1","title":"Spandex.Plug.AddContext.init/1","type":"function"},{"doc":"Finishes a trace, setting status and error based on the HTTP status.","ref":"Spandex.Plug.EndTrace.html","title":"Spandex.Plug.EndTrace","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Spandex.Plug.EndTrace.html#call/2","title":"Spandex.Plug.EndTrace.call/2","type":"function"},{"doc":"Accepts and validates opts for the plug, and underlying tracer. Opts tracer ( :atom ) Required : The tracing module to be used to start the trace. tracer_opts ( :keyword ): Any opts to be passed to the tracer when starting or continuing the trace. - Default: []","ref":"Spandex.Plug.EndTrace.html#init/1","title":"Spandex.Plug.EndTrace.init/1","type":"function"},{"doc":"Starts a trace, skipping ignored routes or methods. Store info in Conn assigns if we actually trace the request.","ref":"Spandex.Plug.StartTrace.html","title":"Spandex.Plug.StartTrace","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Spandex.Plug.StartTrace.html#call/2","title":"Spandex.Plug.StartTrace.call/2","type":"function"},{"doc":"Accepts and validates opts for the plug, and underlying tracer. Opts tracer ( :atom ) Required : The tracing module to be used to start the trace. ignored_methods ( {:list, :string} ): A list of strings representing methods to ignore. A good example would be [&quot;OPTIONS&quot;] - Default: [] ignored_routes ( {:list, [:regex, :string]} ): A list of strings or regexes. If it is a string, it must match exactly. - Default: [] tracer_opts ( :keyword ): Any opts to be passed to the tracer when starting or continuing the trace. - Default: [] span_name ( :string ): The name to be used for the top level span. - Default: &quot;request&quot;","ref":"Spandex.Plug.StartTrace.html#init/1","title":"Spandex.Plug.StartTrace.init/1","type":"function"},{"doc":"Helper methods for accessing Spandex plug assigns.","ref":"Spandex.Plug.Utils.html","title":"Spandex.Plug.Utils","type":"module"},{"doc":"Stores in conn whenever we trace request or not.","ref":"Spandex.Plug.Utils.html#trace/2","title":"Spandex.Plug.Utils.trace/2","type":"function"},{"doc":"Checks conn whenever we trace request or not.","ref":"Spandex.Plug.Utils.html#trace?/1","title":"Spandex.Plug.Utils.trace?/1","type":"function"},{"doc":"A container for all span data and metadata.","ref":"Spandex.Span.html","title":"Spandex.Span","type":"module"},{"doc":"","ref":"Spandex.Span.html#child_of/5","title":"Spandex.Span.child_of/5","type":"function"},{"doc":"Create a new span. Opts id ( :any ) Required name ( :string ) Required service ( :atom ) Required start ( :integer ) Required trace_id ( :any ) Required completion_time ( :integer ) env ( :string ) error ( :keyword ) http ( :keyword ) parent_id ( :any ) private ( :keyword ) - Default: [] resource ( [:atom, :string] ) service_version ( :string ) services ( :keyword ) - Default: [] sql_query ( :keyword ) tags ( :keyword ) - Default: [] type ( :atom ) Also accepts extra opts that are not named here.","ref":"Spandex.Span.html#new/1","title":"Spandex.Span.new/1","type":"function"},{"doc":"","ref":"Spandex.Span.html#span_opts/0","title":"Spandex.Span.span_opts/0","type":"function"},{"doc":"Update an existing span. Opts completion_time ( :integer ) env ( :string ) error ( :keyword ) http ( :keyword ) id ( :any ) name ( :string ) parent_id ( :any ) private ( :keyword ) - Default: [] resource ( [:atom, :string] ) service ( :atom ) service_version ( :string ) services ( :keyword ) - Default: [] sql_query ( :keyword ) start ( :integer ) tags ( :keyword ) - Default: [] trace_id ( :any ) type ( :atom ) Also accepts extra opts that are not named here. Special Meta [ http : [ url : &quot;my_website.com?foo=bar&quot; , status_code : &quot;400&quot; , method : &quot;GET&quot; , query_string : &quot;foo=bar&quot; , user_agent : &quot;Mozilla/5.0...&quot; , request_id : &quot;special_id&quot; ] , error : [ exception : ArgumentError . exception ( &quot;foo&quot; ) , stacktrace : __STACKTRACE__ , error? : true # Used for specifying that a span is an error when there is no exception or stacktrace. ] , sql_query : [ rows : 100 , db : &quot;my_database&quot; , query : &quot;SELECT * FROM users;&quot; ] , # Private has the same structure as the outer meta structure, but private metadata does not # transfer from parent span to child span. private : [ ... ] ]","ref":"Spandex.Span.html#update/3","title":"Spandex.Span.update/3","type":"function"},{"doc":"","ref":"Spandex.Span.html#t:t/0","title":"Spandex.Span.t/0","type":"type"},{"doc":"From the OpenTracing specification : Each SpanContext encapsulates the following state: Any OpenTracing-implementation-dependent state (for example, trace and span ids) needed to refer to a distinct Span across a process boundary Baggage Items, which are just key:value pairs that cross process boundaries","ref":"Spandex.SpanContext.html","title":"Spandex.SpanContext","type":"module"},{"doc":"From the OpenTracing specification : Each SpanContext encapsulates the following state: Any OpenTracing-implementation-dependent state (for example, trace and span ids) needed to refer to a distinct Span across a process boundary Baggage Items, which are just key:value pairs that cross process boundaries","ref":"Spandex.SpanContext.html#t:t/0","title":"Spandex.SpanContext.t/0","type":"type"},{"doc":"The behaviour for a storage strategy for storing an ongoing trace.","ref":"Spandex.Strategy.html","title":"Spandex.Strategy","type":"behaviour"},{"doc":"","ref":"Spandex.Strategy.html#c:delete_trace/1","title":"Spandex.Strategy.delete_trace/1","type":"callback"},{"doc":"","ref":"Spandex.Strategy.html#c:get_trace/1","title":"Spandex.Strategy.get_trace/1","type":"callback"},{"doc":"","ref":"Spandex.Strategy.html#c:put_trace/2","title":"Spandex.Strategy.put_trace/2","type":"callback"},{"doc":"","ref":"Spandex.Strategy.html#c:trace_active?/1","title":"Spandex.Strategy.trace_active?/1","type":"callback"},{"doc":"","ref":"Spandex.Strategy.html#t:tracer/0","title":"Spandex.Strategy.tracer/0","type":"type"},{"doc":"This stores traces in the local process dictionary, scoped by the tracer running the trace, such that you could have multiple traces going at one time by using a different tracer.","ref":"Spandex.Strategy.Pdict.html","title":"Spandex.Strategy.Pdict","type":"module"},{"doc":"A representation of an ongoing trace. baggage : Key-value metadata about the overall trace (propagated across distributed service) id : The trace ID, which consistently refers to this trace across distributed services priority : The trace sampling priority for this trace (propagated across distributed services) spans : The set of completed spans for this trace from this process stack : The stack of active parent spans","ref":"Spandex.Trace.html","title":"Spandex.Trace","type":"module"},{"doc":"A representation of an ongoing trace. baggage : Key-value metadata about the overall trace (propagated across distributed service) id : The trace ID, which consistently refers to this trace across distributed services priority : The trace sampling priority for this trace (propagated across distributed services) spans : The set of completed spans for this trace from this process stack : The stack of active parent spans","ref":"Spandex.Trace.html#t:t/0","title":"Spandex.Trace.t/0","type":"type"},{"doc":"A module that can be used to build your own tracer. Example: defmodule MyApp.Tracer do use Spandex.Tracer , otp_app : :my_app end","ref":"Spandex.Tracer.html","title":"Spandex.Tracer","type":"behaviour"},{"doc":"","ref":"Spandex.Tracer.html#c:configure/1","title":"Spandex.Tracer.configure/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:continue_trace/3","title":"Spandex.Tracer.continue_trace/3","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:continue_trace_from_span/3","title":"Spandex.Tracer.continue_trace_from_span/3","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:current_context/1","title":"Spandex.Tracer.current_context/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:current_span/1","title":"Spandex.Tracer.current_span/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:current_span_id/1","title":"Spandex.Tracer.current_span_id/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:current_trace_id/1","title":"Spandex.Tracer.current_trace_id/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:distributed_context/2","title":"Spandex.Tracer.distributed_context/2","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:finish_span/1","title":"Spandex.Tracer.finish_span/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:finish_trace/1","title":"Spandex.Tracer.finish_trace/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:inject_context/2","title":"Spandex.Tracer.inject_context/2","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:span/3","title":"Spandex.Tracer.span/3","type":"macrocallback"},{"doc":"","ref":"Spandex.Tracer.html#c:span_error/3","title":"Spandex.Tracer.span_error/3","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:start_span/2","title":"Spandex.Tracer.start_span/2","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:start_trace/2","title":"Spandex.Tracer.start_trace/2","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:trace/3","title":"Spandex.Tracer.trace/3","type":"macrocallback"},{"doc":"A schema for the opts that a tracer accepts. Opts adapter ( :atom ) Required : The third party adapter to use disabled? ( :boolean ): Allows for wholesale disabling a tracer - Default: false strategy ( :atom ): The storage and tracing strategy. Currently only supports local process dictionary. - Default: Spandex.Strategy.Pdict sender ( :atom ): Once a trace is complete, it is sent using this module. Defaults to the default_sender/0 of the selected adapter trace_key ( :atom ): Don't set manually. This option is passed automatically. Span Creation service ( :atom ) Required : The default service name to use for spans declared without a service env ( :string ): A name used to identify the environment name, e.g prod or development service_version ( :string ): The version of the service, used for tracking deployments. services ( [{:keyword, :atom}, :keyword] ): A mapping of service name to the default span types. - Default: [] completion_time ( :integer ) error ( :keyword ) http ( :keyword ) id ( :any ) name ( :string ) parent_id ( :any ) private ( :keyword ) - Default: [] resource ( [:atom, :string] ) sql_query ( :keyword ) start ( :integer ) tags ( :keyword ) - Default: [] trace_id ( :any ) type ( :atom ) All tracer functions that take opts use this schema. This also accepts defaults for any value that can be given to a span.","ref":"Spandex.Tracer.html#tracer_opts/0","title":"Spandex.Tracer.tracer_opts/0","type":"function"},{"doc":"","ref":"Spandex.Tracer.html#c:update_span/1","title":"Spandex.Tracer.update_span/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#c:update_top_span/1","title":"Spandex.Tracer.update_top_span/1","type":"callback"},{"doc":"","ref":"Spandex.Tracer.html#t:opts/0","title":"Spandex.Tracer.opts/0","type":"type"},{"doc":"","ref":"Spandex.Tracer.html#t:span_name/0","title":"Spandex.Tracer.span_name/0","type":"type"},{"doc":"","ref":"Spandex.Tracer.html#t:tagged_tuple/1","title":"Spandex.Tracer.tagged_tuple/1","type":"type"},{"doc":"","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Features: Add Service Version Support by @kamilkowalski in https://github.com/spandex-project/spandex/pull/122","ref":"changelog.html#3-2-0-2022-10-20","title":"Change Log - 3.2.0 (2022-10-20)","type":"extras"},{"doc":"Fix interpolated string span and trace names by @gerbal in https://github.com/spandex-project/spandex/pull/136","ref":"changelog.html#bug-fixes","title":"Change Log - Bug Fixes:","type":"extras"},{"doc":"@gerbal made their first contribution in https://github.com/spandex-project/spandex/pull/136","ref":"changelog.html#new-contributors","title":"Change Log - New Contributors:","type":"extras"},{"doc":"Encode logger metadata as string. by @aselder in https://github.com/spandex-project/spandex/pull/127 Set up sponsorship links by @GregMefford in https://github.com/spandex-project/spandex/pull/132 Guard clauses for trace and span macros by @GregMefford in https://github.com/spandex-project/spandex/pull/130 Misc doc changes by @kianmeng in https://github.com/spandex-project/spandex/pull/128","ref":"changelog.html#3-1-0-2021-10-23","title":"Change Log - 3.1.0 (2021-10-23)","type":"extras"},{"doc":"","ref":"changelog.html#3-0-3-2020-11-10","title":"Change Log - 3.0.3 (2020-11-10)","type":"extras"},{"doc":"Bug Fixes: add a name to failed traces (#116)","ref":"changelog.html#3-0-2-2020-07-13","title":"Change Log - 3.0.2 (2020-07-13)","type":"extras"},{"doc":"Bug Fixes: configure sender in tests","ref":"changelog.html#3-0-1-2020-05-14","title":"Change Log - 3.0.1 (2020-05-14)","type":"extras"},{"doc":"Breaking Changes: allow headers to be passed into Spandex.distributed_context/2 (#113)","ref":"changelog.html#3-0-0-2020-05-14","title":"Change Log - 3.0.0 (2020-05-14)","type":"extras"},{"doc":"Bug Fixes: Set Logger.metadata when continue_trace/3 is called as well (#111)","ref":"changelog.html#2-4-4-2020-4-28","title":"Change Log - 2.4.4 (2020-4-28)","type":"extras"},{"doc":"Bug Fixes: No unmatched returns (#109)","ref":"changelog.html#2-4-3-2020-3-25","title":"Change Log - 2.4.3 (2020-3-25)","type":"extras"},{"doc":"Bug Fixes: Add missing trace_id to logger metadata (#107)","ref":"changelog.html#2-4-2-2020-1-13","title":"Change Log - 2.4.2 (2020-1-13)","type":"extras"},{"doc":"Bug Fixes: Resolve unknown dialyzer type error Bug Fixes: don't silence errors on span update calls (#90) update span on finish trace/update (#88)","ref":"changelog.html#2-4-1-2018-12-11","title":"Change Log - 2.4.1 (2018-12-11)","type":"extras"},{"doc":"Features: Add(bring back) span and trace decorators The below is before automated changelog management","ref":"changelog.html#2-4-0-2018-10-11","title":"Change Log - 2.4.0 (2018-10-11)","type":"extras"},{"doc":"Added Spandex.current_context/1 and Spandex.Tracer.current_context/1 functions, which get a Spandex.SpanContext struct based on the current context. Spandex.inject_context/3 and Spandex.Tracer.inject_context/2 functions, which inject a distributed tracing context into a list of HTTP headers. Changed The Spandex.Adapter behaviour now requires an inject_context/3 callback, which encodes a Spandex.SpanContext as HTTP headers for distributed tracing.","ref":"changelog.html#2-3-0","title":"Change Log - 2.3.0","type":"extras"},{"doc":"Added The Spandex.Trace struct now includes priority and baggage fields, to support priority sampling of distributed traces and trace-level baggage, respectively. More details about these concepts can be found in the OpenTracing documentation. An updated version of the spandex_datadog library will enable support for this feature in terms of the Spandex.Adapter and Sender APIs. Changed It is no longer required that you specify the env option. If not specified, it will default to nil . This is useful, for example, for allowing the Datadog trace collector configured default to be used. The Spandex.Adapter.distributed_context/2 callback now expects a SpanContext struct to be returned, rather than a Map . Similarly, the Spandex.continue_trace function now expects a SpanContext struct rather than a separate trace_id and span_id . The sender API now calls the send_trace function, passing in a Spandex.Trace struct, rather than passing a list of Spandex.Span structs. This means that you need to update the spandex_datadog to a compatible version. Deprecated Spandex.continue_trace/4 is deprecated in favor of Spandex.continue_trace/3 Similarly, Tracer.continue_trace/4 is deprecated in favor of Tracer.continue_trace/3","ref":"changelog.html#2-2-0","title":"Change Log - 2.2.0","type":"extras"},{"doc":"It is recommended to reread the README, to see the upgrade guide and understand the changes. Added Massive changes, including separating adapters into their own repositories Changed Many interface changes, specifically around return values Removed Adapters now exist in their own repositories","ref":"changelog.html#2-1-0","title":"Change Log - 2.1.0","type":"extras"},{"doc":"Added private key, when updating spans, for non-inheriting meta","ref":"changelog.html#1-6-1-2018-06-04","title":"Change Log - 1.6.1 - 2018-06-04","type":"extras"},{"doc":"Added Storage strategy behaviour Changed Centralize most storage logic, requiring only the most adapter specific behaviour to be defined by the adapter.","ref":"changelog.html#1-6-0-2018-06-04","title":"Change Log - 1.6.0 - 2018-06-04","type":"extras"},{"doc":"Changed Interface for updating span metadata, and creating with metadata has been updated Check documentation for examples","ref":"changelog.html#1-5-0-2018-06-02","title":"Change Log - 1.5.0 - 2018-06-02","type":"extras"},{"doc":"Changed Resolved an issue with distributed trace header parsing","ref":"changelog.html#1-4-1-2018-05-31","title":"Change Log - 1.4.1 - 2018-05-31","type":"extras"},{"doc":"Added The tracer pattern Modernized configuration More: Please read the readme again!","ref":"changelog.html#1-4-0-2018-05-29","title":"Change Log - 1.4.0 - 2018-05-29","type":"extras"},{"doc":"Added Support distributed tracing via trace headers. Added a changelog Changed No new changes","ref":"changelog.html#1-3-4-2018-05-25","title":"Change Log - 1.3.4 - 2018-05-25","type":"extras"},{"doc":"View the documentation Spandex is a library for tracing your elixir application. Tracing is a monitoring tool that allows you get extremely granular information about the runtime of your system. Using distributed tracing, you can also get a view of how requests make their way through your entire ecosystem of microservices or applications. Currently, Spandex only supports integrating with datadog , but it is built to be agnostic to what platform you choose to view your trace data. Eventually it should support Open Zipkin, Stackdriver, and any other trace viewer/aggregation tool you'd like to integrate with. We are still under active development, working on moving to a more standard/generic implementation of the internals. Contributions welcome!","ref":"readme.html","title":"","type":"extras"},{"doc":"The 3.0 release only involves ensuring that you're using the latest adapter, which will be explicit in its dependency on a spandex version. This major version was done only to solve for breaking changes between the adapter and spandex core, in order to honor semver and also not break everyone's installation.","ref":"readme.html#3-0-release","title":" - 3.0 Release","type":"extras"},{"doc":"This is Datadog-specific since that's currently the only adapter. Include the adapter as a dependency (see below). Replace any occurrences of Spandex.Adapters.Datadog with SpandexDatadog.Adapter in your code. Replace any occurrences of Spandex.Adapters.ApiSender with SpandexDatadog.ApiSender in your code.","ref":"readme.html#2-0-upgrade-guide","title":" - 2.0 Upgrade Guide","type":"extras"},{"doc":"Datadog Thats it so far! If you want another adapter, it should be relatively easy to write! This library is in charge of handling the state management of spans, and the adapter is just in charge of generating certain values and ultimately sending the values to the service.","ref":"readme.html#adapters","title":" - Adapters","type":"extras"},{"doc":"def deps do [ { :spandex , &quot;~&gt; 3.2&quot; } ] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"Define your tracer: defmodule MyApp.Tracer do use Spandex.Tracer , otp_app : :my_app end Configure it: config :my_app , MyApp.Tracer , service : :my_api , adapter : SpandexDatadog.Adapter , disabled? : false , env : &quot;PROD&quot; Or at runtime, by calling configure/1 (usually in your application's startup) MyApp.Tracer . configure ( disabled? : System . get_env ( &quot;TRACE&quot; ) != &quot;true&quot; ) For more information on Tracer configuration, view the docs for Spandex.Tracer . There you will find the documentation for the opts schema. The entire configuration can also be passed into each function in your tracer to be overridden if desired. For example: MyApp.Tracer.start_span(&quot;span_name&quot;, service: :some_special_service) Your configuration and the configuration in your config files are merged together, to avoid needing to specify this config at all times. To bypass the Tracer pattern entirely, you can call directly into the functions in Spandex , like Spandex.start_span(&quot;span_name&quot;, [adapter: Foo, service: :bar]) . Note that in this case, you will need to specify all of the configuration options in each call, because the Tracer is not managing the defaults for you. Adapter specific configuration For adapter configuration, see the documentation for that adapter","ref":"readme.html#setup-and-configuration","title":" - Setup and Configuration","type":"extras"},{"doc":"There are 3 plugs provided for usage w/ Phoenix: Spandex.Plug.StartTrace - See module docs for options. Goes as early in your pipeline as possible. Spandex.Plug.AddContext - See moduledoc for options. Either after the router, or inside a pipeline in the router. Spandex.Plug.EndTrace - Must go after your router.","ref":"readme.html#phoenix-plugs","title":" - Phoenix Plugs","type":"extras"},{"doc":"Individual adapters can support distributed tracing. See their documentation for more information.","ref":"readme.html#distributed-tracing","title":" - Distributed Tracing","type":"extras"},{"doc":"In general, you'll probably want the current span_id and trace_id in your logs, so that you can find them in your tracing service. Make sure to add span_id and trace_id to logger_metadata config :logger , :console , metadata : [ :request_id , :trace_id , :span_id ]","ref":"readme.html#logger-metadata","title":" - Logger metadata","type":"extras"},{"doc":"The nicest interface for working with spans is the span macro, illustrated in span_me_also below. defmodule ManuallyTraced do require Spandex # Does not handle exceptions for you. def trace_me ( ) do Tracer . start_trace ( &quot;my_trace&quot; ) #also opens a span Tracer . update_span ( service : :my_app , type : :db ) result = span_me ( ) Tracer . finish_trace ( ) result end # Does not handle exceptions for you. def span_me ( ) do Tracer . start_span ( &quot;this_span&quot; ) Tracer . update_span ( service : :my_app , type : :web ) result = span_me_also ( ) Tracer . finish_span ( ) end # Handles exception at the span level. Trace still must be reported. def span_me_also ( ) do Tracer . span ( &quot;span_me_also&quot; ) do ... end end end Metadata See the module documentation for Spandex.Span as well as the documentation for the structs contained as keys for that struct. They illustrate the keys that are known to either be common keys or to have UI sugar with certain clients. Its hard to find any kind of list of these published anywhere, so let me know if you know of more! For example: Spandex . update_span ( type : :db , http : [ url : &quot;/posts&quot; , status_code : 400 ] , sql_query : [ query : &quot;SELECT * FROM posts&quot; , rows : 10 ] )","ref":"readme.html#general-usage","title":" - General Usage","type":"extras"},{"doc":"The current trace_id and span_id can be retrieved and later used (for example, from another process) as follows: trace_id = Tracer . current_trace_id ( ) span_id = Tracer . current_span_id ( ) span_context = % SpanContext { trace_id : trace_id , parent_id : span_id } Tracer . continue_trace ( &quot;new_trace&quot; , span_context ) New spans can then be logged from there and sent in a separate batch.","ref":"readme.html#asynchronous-processes","title":" - Asynchronous Processes","type":"extras"},{"doc":"There is (currently and temporarily) only one storage strategy, which can be changed via the strategy option. See Tracer opt documentation for an example of setting it. To implement your own (ETS adapter should be on its way), simply implement the Spandex.Strategy behaviour. Keep in mind that the strategy is not an atomic pattern. It represents retrieving and wholesale replacing a trace, meaning that it is not safe to use across processes or concurrently. Each process should have its own store for its own generated spans. This should be fine because you can send multiple batches of spans for the same trace separately.","ref":"readme.html#strategies","title":" - Strategies","type":"extras"},{"doc":"Because the decorator library can cause conflicts when it interacts with other dependencies in the same project, we support it as an optional dependency. This allows you to disable it if it causes problems for you, but it also means that you need to explicitly include some version of decorator in your application's dependency list: # mix.exs defp deps do [ { :decorator , &quot;~&gt; 1.2&quot; } ] end Then, configure the Spandex decorator with your default tracer: config :spandex , :decorators , tracer : MyApp.Tracer Span function decorators take an optional argument which is the attributes to update the span with. One of those attributes can be the :tracer in case you want to override the default tracer (e.g., in case you want to use multiple tracers). IMPORTANT If you define multiple clauses for a function, you'll have to decorate all of the ones you want to span. defmodule TracedModule do use Spandex.Decorators @decorate trace ( service : :my_app , type : :web ) def trace_me ( ) do span_1 ( ) end @decorate span ( name : &quot;span_1&quot; ) def span_1 ( ) do inner_span_1 ( ) end @decorate span ( ) def inner_span_1 ( ) do _ = ThirdPartyApi . different_service_call ( ) inner_span_2 ( ) end @decorate span ( tracer : MyApp.OtherTracer ) def inner_span_2 ( ) do &quot;this produces a span stack to be reported by another tracer&quot; end # Multiple Clauses @decorate span ( ) def divide ( n , 0 ) , do : { :error , :divide_by_zero } @decorate span ( ) def divide ( n , m ) , do : n / m end defmodule ThirdPartyApi do use Spandex.Decorators @decorate span ( service : :third_party , type : :cache ) def different_service_call ( ) do ... end end Note: Decorators don't magically do everything. It often makes a lot of sense to use Tracer.update_span from within your function to add details that are only available inside that same function.","ref":"readme.html#decorators","title":" - Decorators","type":"extras"},{"doc":"Check out spandex_ecto .","ref":"readme.html#ecto-tracing","title":" - Ecto Tracing","type":"extras"},{"doc":"Check out spandex_phoenix .","ref":"readme.html#phoenix-tracing","title":" - Phoenix Tracing","type":"extras"}]